/* subtract data from A to B*/
/* the usage is 'img_sub file1 file2 file3 offset' */
/* file3 = (file1+file2) - offset */

#include<stdio.h>
#include<stdlib.h>
#include<string.h>
#include<math.h>

#define INTEL

#define HiPic_Header_Size 64

struct hipic_header
//typedef struct
{
	char				head[2];
	unsigned short		comment_length;
	unsigned short		width;
	unsigned short		height;
	unsigned short		x_offset;
	unsigned short		y_offset;
	unsigned short		type;
	char				reserved[63 - 13];
	char				*comment;
} HiPic_Header;

static	FILE *fi1, *fi2, *fo, *fc;

void	main(argc,argv)
int		argc;
char	*argv[];
{
	short			*simage1, *simage2, *soutimg, offset;
	double			*dimage1, *dimage2, *doutimg;
	int				x_size1, y_size1, x_size2, y_size2;
	long			i, jj;

		if(argc < 5)   // when bad number of parameters
		{
			printf("The usage is 'img_sub file1 file2 file3 offset'\n");
			printf(" file3 = (file1+file2) - offset\n");
			exit(-1);
		}
//open input files and output file
		if((fi1 = fopen(argv[1],"rb")) == NULL) // file1 open
			{ printf("can not open file1 for input\n"); exit(-1);}
		if((fi2 = fopen(argv[2],"rb")) == NULL) // file2 open
			{ printf("can not open file2 for input\n"); exit(-1);}
		if((fo  = fopen(argv[3],"wb")) == NULL) // file3 open
			{ printf("can not open file3 for output\n"); exit(-1);}
		offset = atoi(argv[4]);
//
//		if((fc  = fopen("rawdata.dat","w")) == NULL) // rawdata open
//			{ printf("can not open correlation file for output\n"); exit(-1);}

// read comment and image data from file1
		if (fread(&HiPic_Header, sizeof(char), HiPic_Header_Size, fi1) != HiPic_Header_Size)
			{ fprintf(stderr, "EOF in %s (header)\n", argv[1]); exit(-1);}
		if (strncmp(HiPic_Header.head, "IM", 2))
			{ fprintf(stderr, "This is not HiPIc image file.\n"); exit(-1);}

		HiPic_Header.comment = (char *) malloc(HiPic_Header.comment_length + 1);
		if (HiPic_Header.comment == NULL)
			{ fprintf(stderr, "Connot allocate memory (HiPic_Header.comment)\n"); exit(-1);}
		if (fread(HiPic_Header.comment, sizeof(char), HiPic_Header.comment_length, fi1) != HiPic_Header.comment_length)
			{ fprintf(stderr, "EOF found (comment)\n"); exit(-1);}
		x_size1 = HiPic_Header.width;  printf("x_size1         %d \n", x_size1);
		y_size1 = HiPic_Header.height; printf("y_size1         %d \n", y_size1);
		printf("comment length1 %d \n\n", HiPic_Header.comment_length);
//  printf("-------------------------------\n");
//  printf("%s\n", HiPic_Header.head);
//  printf("%d\n", HiPic_Header.comment_length);
//  printf("%d\n", HiPic_Header.width);
//  printf("%d\n", HiPic_Header.height);
//  printf("%d\n", HiPic_Header.x_offset);
//  printf("%d\n", HiPic_Header.y_offset);
  printf("%d\n", HiPic_Header.type);
//  printf("%s\n", HiPic_Header.reserved);
//  printf("%s\n", HiPic_Header.comment);
//  printf("-------------------------------\n");



		if (HiPic_Header.type == 2){
			simage1 = (short *) malloc(x_size1 * y_size1 * sizeof(short));
			if ((i = fread( simage1, sizeof(short), x_size1 * y_size1, fi1)) != x_size1 * y_size1){
				fprintf(stderr, "EOF found in the data of %s (%d %d) \n", argv[1], i, x_size1*y_size1);
				exit(-1);
			}
		}
		else if(HiPic_Header.type == 10){
			dimage1 = (double *) malloc(x_size1 * y_size1 * sizeof(double));
			if ((i = fread(dimage1, sizeof(double), x_size1 * y_size1, fi1)) != x_size1 * y_size1){
				fprintf(stderr, "EOF found in the data of %s (%d %d) \n", argv[1], i, x_size1*y_size1);
				exit(-1);
			}
		}
		else{
			printf("Unknown file type in file1!");
			exit(-9);
		}

// write header and comment in output data file
		if (fwrite(&HiPic_Header, sizeof(char), HiPic_Header_Size, fo) != HiPic_Header_Size){
			fprintf(stderr, "something wrong in %s (header)\n", argv[3]);
			exit(-1);
		}
		if (fwrite(HiPic_Header.comment, sizeof(char), HiPic_Header.comment_length, fo) != HiPic_Header.comment_length){
			fprintf(stderr, "something wrong in comment of %s (header)\n", argv[3]);
			exit(-1);
		}

// read comment and image data from file2
		if (fread(&HiPic_Header, sizeof(char), HiPic_Header_Size, fi2) != HiPic_Header_Size){
			fprintf(stderr, "EOF in %s (header)\n", argv[2]);
			exit(-1);
		}
		if (strncmp(HiPic_Header.head, "IM", 2)){
			fprintf(stderr, "2This is not HiPIc image file.\n");
			exit(-1);
		}

		HiPic_Header.comment = (char *) malloc(HiPic_Header.comment_length + 1);
		if (HiPic_Header.comment == NULL){
			fprintf(stderr, "Connot allocate memory (HiPic_Header.comment)\n");
			exit(-1);
		}
		if (fread(HiPic_Header.comment, sizeof(char), HiPic_Header.comment_length, fi2) != HiPic_Header.comment_length){
			fprintf(stderr, "EOF found (comment)\n");
			exit(-1);
		}
		x_size2 = HiPic_Header.width;  printf("x_size2         %d \n", x_size2);
		y_size2 = HiPic_Header.height; printf("y_size2         %d \n", y_size2);
		printf("comment length2 %d \n\n", HiPic_Header.comment_length);

		if (HiPic_Header.type == 2){
			simage2 = (short *) malloc(x_size2 * y_size2 * sizeof(short));
			if ((i = fread(simage2, sizeof(short), x_size2 * y_size2, fi2)) != x_size2 * y_size2){
				fprintf(stderr, "EOF found in the data of %s (%d %d) \n", argv[1], i, x_size2*y_size2);
				exit(-1);
			}
		}
		else if(HiPic_Header.type == 10){
			dimage2 = (double *) malloc(x_size2 * y_size2 * sizeof(double));
			if ((i = fread(dimage2, sizeof(double), x_size2 * y_size2, fi2)) != x_size2 * y_size2){
				fprintf(stderr, "EOF found in the data of %s (%d %d) \n", argv[1], i, x_size2*y_size2);
				exit(-1);
			}
		}
		else{
			printf("Unknown file type in file2!");
			exit(-9);
		}

// calculate data
		if (HiPic_Header.type == 2){
			soutimg = (short *) malloc(x_size2 * y_size2 * sizeof(short));
			for(jj = 0; jj < x_size2 * y_size2 ; ++ jj){
				*(soutimg+jj) = (*(simage1+jj) + *(simage2+jj) - offset);
//				fprintf(fc,"%d %d %d", jj, *(simage1+jj), *(simage2+jj));
			}
// write image to file3
			if (i = fwrite(soutimg , sizeof(short), x_size2 * y_size2, fo) > x_size2 * y_size2 * sizeof(short)){
				fprintf(stderr, "something wrong in data area %d  %d\n", i, x_size2 * y_size2);
				exit(-1);
			}
		}
		else if (HiPic_Header.type == 10){
			doutimg = (double *) malloc(x_size2 * y_size2 * sizeof(double));
			for(jj = 0; jj < x_size2 * y_size2 ; ++ jj){
				*(doutimg+jj) = (*(dimage1+jj) + *(dimage2+jj) - offset);
//				fprintf(fc,"%d %13.8f %13.8f %13.8f\n", jj, *(dimage1+jj), *(dimage2+jj), *(doutimg+jj));
			}
// write image to file3
			if (i = fwrite(doutimg , sizeof(double), x_size2 * y_size2, fo) > x_size2 * y_size2 * sizeof(double)){
				fprintf(stderr, "something wrong in data area %d  %d\n", i, x_size2 * y_size2);
				exit(-1);
			}
		}

// close files
		fclose(fi1);
		fclose(fi2);
		fclose(fo);
//		fclose(fc);

//  printf("-------------------------------\n");
//  printf("%s\n", HiPic_Header.head);
//  printf("%d\n", HiPic_Header.comment_length);
//  printf("%d\n", HiPic_Header.width);
//  printf("%d\n", HiPic_Header.height);
//  printf("%d\n", HiPic_Header.x_offset);
//  printf("%d\n", HiPic_Header.y_offset);
//  printf("%d\n", HiPic_Header.type);
//  printf("%s\n", HiPic_Header.reserved);
//  printf("%s\n", HiPic_Header.comment);
//  printf("-------------------------------\n");

//fin:
	if (HiPic_Header.type == 1)
	{
		free(simage1);
		free(simage2);
		free(soutimg);
	}
	else if (HiPic_Header.type == 10)
	{
		free(dimage1);
		free(dimage2);
		free(doutimg);
	}
	free(HiPic_Header.comment);
	exit(0);
}
